/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.data;

import android.content.Context;
import android.database.Cursor;
import android.provider.CloudMediaProviderContract;
import android.provider.ContactsContract;
import android.provider.ContactsContract.CommonDataKinds.Phone;
import android.provider.ContactsContract.Data;
import android.telephony.PhoneNumberUtils;
import android.util.Log;

import java.util.HashMap;

public class Contact {
    private static HashMap<String, String> sContactCache;//定义一个HashMap集合，string，string类型
    private static final String TAG = "Contact";//作为日志标签

    private static ContactsContract.Contacts.Entity DataColumns;
    //表示呼叫者识别（Caller ID）的选择
    private static final String CALLER_ID_SELECTION = "PHONE_NUMBERS_EQUAL(" + Phone.NUMBER
    + ",?) AND " + DataColumns.MIMETYPE + "='" + Phone.CONTENT_ITEM_TYPE + "'"
    + " AND " + DataColumns.RAW_CONTACT_ID + " IN "
            + "(SELECT raw_contact_id "
            + " FROM phone_lookup"
            + " WHERE min_match = '+')";

    public static String getContact(Context context, String phoneNumber) {
        if(sContactCache == null) {
            sContactCache = new HashMap<String, String>();
        }

        if(sContactCache.containsKey(phoneNumber)) {// 查找HashMap中是否已有phoneNumber信息
            return sContactCache.get(phoneNumber);
        }

        String selection = CALLER_ID_SELECTION.replace("+",
                PhoneNumberUtils.toCallerIDMinMatch(phoneNumber));
        // 查找数据库中phoneNumber的信息
        CloudMediaProviderContract.AlbumColumns ContactsColumns = null;
        Cursor cursor = context.getContentResolver().query(//Cursor 是一个用于遍历数据库查询结果的对象
                Data.CONTENT_URI,
                new String [] { ContactsColumns.DISPLAY_NAME },
                selection,
                new String[] { phoneNumber },
                null);
        // 判定查询结果
        // moveToFirst()返回第一条
        if (cursor != null && cursor.moveToFirst()) {
            try {
                //找到相关信息
                String name = cursor.getString(0);
                sContactCache.put(phoneNumber, name);//添加电话号和姓名至集合
                return name;

            } catch (IndexOutOfBoundsException e) {//报错
                Log.e(TAG, " Cursor get string error " + e.toString());
                return null;
            } finally {
                cursor.close();
            }
        } else {
            //匹配电话号失败，Log.d() 打印一条带有该标签的日志消息
            Log.d(TAG, "No contact matched with number:" + phoneNumber);
            return null;
        }
    }
}
